#pragma once
#include "stdafx.h"
#include "FbxExporter.h"
#include "FbxString.h"
#include "FbxStreamOptions.h"
#include "FbxDocument.h"
#include "FbxRenamingStrategy.h"
#include "FbxSdkManager.h"
#include "FbxClassId.h"

namespace Skill
{
	namespace FbxSDK
	{
		namespace IO
		{	
			void FbxExporter::CollectManagedMemory()
			{
				this->_ExportOptions = nullptr;
				FbxIO::CollectManagedMemory();
			}

			FBXOBJECT_DEFINITION(FbxExporter,KFbxExporter);
			
			REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxExporter,KFbxStreamOptions,GetExportOptions(),FbxStreamOptions,ExportOptions);
			bool FbxExporter::Initialize(String^ fileName)
			{
				return FbxIO::Initialize(fileName);
			}			

			bool FbxExporter::Export(FbxDocument^ document, FbxStreamOptions^ streamOptions)
			{
				return _Ref()->Export(document->_Ref(),streamOptions->_Ref());
			}
			bool FbxExporter::Export(FbxDocument^ document)
			{
				return _Ref()->Export(document->_Ref());
			}
			void FbxExporter::ReleaseExportOptions(FbxStreamOptions^ streamOptions)
			{
				_Ref()->ReleaseExportOptions(streamOptions->_Ref());
			}
			VALUE_PROPERTY_GET_DEFINATION(FbxExporter,GetFileFormat(),int,FileFormat);			
			void FbxExporter::FileFormat::set(int value)
			{
				_Ref()->SetFileFormat(value);
			}
			bool FbxExporter::IsFBX::get()
			{
				return _Ref()->IsFBX();
			}
			bool FbxExporter::SetFileExportVersion(FbxString^ version, FbxSceneRenamer::RenamingMode renamingMode)
			{
				return _Ref()->SetFileExportVersion(*version->_Ref(), (KFbxSceneRenamer::ERenamingMode)renamingMode);
			}			

#ifndef DOXYGEN_SHOULD_SKIP_THIS				
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS
		}
	}
}