#pragma once
#include "stdafx.h"
#include "FbxIOSettings.h"
#include "FbxClassId.h"
#include "FbxSdkManager.h"
#include "FbxProperty.h"
#include "FbxDataType.h"
#include "FbxString.h"

namespace Skill
{
	namespace FbxSDK
	{
		namespace IO
		{	
			void FbxSoInfo::CollectManagedMemory()
			{
				this->ASF = nullptr;
			}			
			void FbxSoInfo::Reset(ImpExp impExp)
			{
				_Ref()->Reset((KsoInfo::EIMPEXP)impExp);
			}
			void FbxSoInfo::SetTimeMode(FbxTime::TimeMode timeMode, double customFrameRate)
			{
				_Ref()->SetTimeMode((KTime::ETimeMode)timeMode,customFrameRate);
			}
			FbxTime::TimeMode FbxSoInfo::TimeMode::get()
			{
				return (FbxTime::TimeMode)_Ref()->GetTimeMode();
			}					
			FbxTime^ FbxSoInfo::FramePeriod::get()
			{						
				return gcnew FbxTime(_Ref()->GetFramePeriod());				
			}
			void FbxSoInfo::SetASFScene(FbxObject^ ASFScene, bool ASFSceneOwned)
			{
				_Ref()->SetASFScene(ASFScene->_Ref(),ASFSceneOwned);
				this->ASF = ASFScene;
			}
			FbxObject^ FbxSoInfo::GetASFScene()
			{
				if(ASF)
					return ASF;
				else
				{					
					ASF = FbxCreator::CreateFbxObject(_Ref()->GetASFScene());
					return ASF;
				}
			}													

			FBXOBJECT_DEFINITION(FbxIOSettings,KFbxIOSettings);

			void FbxIOSettings::CollectManagedMemory()
			{
				this->_ImpInfo = nullptr;
				this->_ExpInfo = nullptr;
				FbxObject::CollectManagedMemory();
			}

			void FbxIOSettings::AllocateIOSettings(FbxSdkManager^ manager)
			{
				KFbxIOSettings::AllocateIOSettings(*manager->_Ref());
			}

			bool FbxIOSettings::IsIOSettingsAllocated()
			{
				return KFbxIOSettings::IsIOSettingsAllocated();
			}					
			void FbxIOSettings::FreeIOSettings()
			{
				_Ref()->FreeIOSettings();
			}

			FbxIOSettings^ FbxIOSettings::IOSettingsRef::get()
			{
				if(refIO )
					refIO->_SetPointer(&KFbxIOSettings::IOSettingsRef(),false);
				else
					refIO = gcnew FbxIOSettings(&KFbxIOSettings::IOSettingsRef());
				return refIO;				
			}		

			FbxProperty^ FbxIOSettings::AddPropertyGroup(String^ name, FbxDataType^ dataType, String^ label)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				STRINGTO_CONSTCHAR_ANSI(l,label);

				KFbxProperty p = _Ref()->AddPropertyGroup(n,*dataType->_Ref(),l);
				FbxProperty^ p1 = gcnew FbxProperty(p);				
				FREECHARPOINTER(n);
				FREECHARPOINTER(l);
				return p1;
			}

			FbxProperty^ FbxIOSettings::AddPropertyGroup(String^ name)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);				
				KFbxProperty p = _Ref()->AddPropertyGroup(n);
				FbxProperty^ p1 = gcnew FbxProperty(p);
				FREECHARPOINTER(n);				
				return p1;
			}

			FbxProperty^ FbxIOSettings::AddPropertyGroup(FbxProperty^ parentProperty, 
				String^ name,
				FbxDataType^ dataType, 
				String^ label,
				bool visible,
				bool savable,
				bool enabled)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				STRINGTO_CONSTCHAR_ANSI(l,label);

				KFbxProperty p = _Ref()->AddPropertyGroup(*parentProperty->_Ref(),n,*dataType->_Ref(),l,visible,savable,enabled);
				FbxProperty^ p1 = gcnew FbxProperty(p);
				FREECHARPOINTER(n);
				FREECHARPOINTER(l);
				return p1;
			}

			FbxProperty^ FbxIOSettings::AddPropertyGroup(FbxProperty^ parentProperty, 
				String^ name)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);				
				KFbxProperty p = _Ref()->AddPropertyGroup(*parentProperty->_Ref(),n);
				FbxProperty^ p1 = gcnew FbxProperty(p);
				FREECHARPOINTER(n);				
				return p1;
			}

			FbxProperty^ FbxIOSettings::GetProperty(String^ name)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);				
				KFbxProperty p = _Ref()->GetProperty(n);
				FbxProperty^ p1 = gcnew FbxProperty(p);
				FREECHARPOINTER(n);				
				return p1;
			}
			FbxProperty^ FbxIOSettings::GetProperty(FbxProperty^ parentProperty,String^ name)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);				
				KFbxProperty p = _Ref()->GetProperty(*parentProperty->_Ref(),n);
				FbxProperty^ p1 = gcnew FbxProperty(p);
				FREECHARPOINTER(n);				
				return p1;
			}
			bool FbxIOSettings::GetBoolProp(String^ name, bool defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				bool b = _Ref()->GetBoolProp(n,defValue);
				FREECHARPOINTER(n);	
				return b;
			}
			void FbxIOSettings::SetBoolProp(String^ name, bool value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetBoolProp(n,value);
				FREECHARPOINTER(n);					
			}

			double FbxIOSettings::GetDoubleProp(String^ name, double defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				double d = _Ref()->GetDoubleProp(n,defValue);
				FREECHARPOINTER(n);	
				return d;
			}
			void FbxIOSettings::SetDoubleProp(String^ name, double value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetDoubleProp(n,value);
				FREECHARPOINTER(n);					
			}
			int FbxIOSettings::GetIntProp(String^ name, int defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				int i = _Ref()->GetIntProp(n,defValue);
				FREECHARPOINTER(n);	
				return i;
			}
			void FbxIOSettings::SetIntProp(String^ name, int value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetIntProp(n,value);
				FREECHARPOINTER(n);					
			}

			FbxTime^ FbxIOSettings::GetFbxTimeProp(String^ name, FbxTime^ defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				KTime kt = _Ref()->GetKTimeProp(n,*defValue->_Ref());
				FREECHARPOINTER(n);	
				FbxTime^ time = gcnew FbxTime(kt);				
				return time;
			}
			void FbxIOSettings::SetFbxTimeProp(String^ name, FbxTime^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetKTimeProp(n,*value->_Ref());
				FREECHARPOINTER(n);					
			}

			FbxString^ FbxIOSettings::GetEnumProp(String^ name, FbxString^ defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				KString ks = _Ref()->GetEnumProp(n,*defValue->_Ref());
				FREECHARPOINTER(n);	
				FbxString^ st = gcnew FbxString(ks);				
				return st;
			}
			int FbxIOSettings::GetEnumProp(String^ name, int defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				int i = _Ref()->GetEnumProp(n,defValue);
				FREECHARPOINTER(n);	
				return i;
			}
			int FbxIOSettings::GetEnumIndex(String^ name, FbxString^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				int i = _Ref()->GetEnumIndex(n,*value->_Ref());
				FREECHARPOINTER(n);	
				return i;
			}
			void FbxIOSettings::SetEnumProp(String^ name, FbxString^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetEnumProp(n,*value->_Ref());
				FREECHARPOINTER(n);					
			}
			void FbxIOSettings::SetEnumProp(String^ name, int value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetEnumProp(n,value);
				FREECHARPOINTER(n);					
			}
			void FbxIOSettings::RemoveEnumPropValue(String^ name, FbxString^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->RemoveEnumPropValue(n,*value->_Ref());
				FREECHARPOINTER(n);
			}
			void FbxIOSettings::EmptyEnumProp(String^ name)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->EmptyEnumProp(n);
				FREECHARPOINTER(n);
			}
			bool FbxIOSettings::SetFlag(String^ name, Skill::FbxSDK::FbxPropertyFlags::FbxPropertyFlagsType propFlag, bool value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				bool b =_Ref()->SetFlag(n,(fbxsdk_200901::FbxPropertyFlags::eFbxPropertyFlags)propFlag,value);
				FREECHARPOINTER(n);
				return b;
			}
			FbxString^ FbxIOSettings::GetStringProp(String^ name, FbxString^ defValue)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				KString ks = _Ref()->GetStringProp(n,*defValue->_Ref());
				FREECHARPOINTER(n);	
				FbxString^ st = gcnew FbxString(ks);				
				return st;
			}
			void FbxIOSettings::SetStringProp(String^ name, FbxString^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				_Ref()->SetStringProp(n,*value->_Ref());
				FREECHARPOINTER(n);
			}
			bool FbxIOSettings::ReadXMLFile(String^ path)
			{
				STRINGTO_CONSTCHAR_ANSI(p,path);
				KString s(p);
				bool b = _Ref()->ReadXMLFile(s);
				FREECHARPOINTER(p);
				return b;
			}			
			bool FbxIOSettings::WriteXMLFile(String^ path)
			{
				STRINGTO_CONSTCHAR_ANSI(p,path);
				KString s(p);
				bool b = _Ref()->WriteXMLFile(s);
				FREECHARPOINTER(p);
				return b;
			}
			bool FbxIOSettings::WriteXmlPropToFile(String^ fullPath, String^ propPath)
			{
				STRINGTO_CONSTCHAR_ANSI(f,fullPath);
				KString sfull(f);
				STRINGTO_CONSTCHAR_ANSI(p,propPath);
				KString sprop(p);
				bool b = _Ref()->WriteXmlPropToFile(sfull,sprop);
				FREECHARPOINTER(f);
				FREECHARPOINTER(p);
				return b;
			}
			bool FbxIOSettings::WriteXmlPropToRegistry(String^ regKeyName, String^ regValueName, String^ propPath, String^ regPath)
			{
				STRINGTO_CONSTCHAR_ANSI(rk,regKeyName);
				KString srk(rk);
				STRINGTO_CONSTCHAR_ANSI(rv,regValueName);
				KString srv(rv);
				STRINGTO_CONSTCHAR_ANSI(pp,propPath);
				KString spp(pp);
				STRINGTO_CONSTCHAR_ANSI(rp,regPath);
				KString srp(rp);
				bool b = _Ref()->WriteXmlPropToRegistry(srk,srv,spp,srp);
				FREECHARPOINTER(rk);
				FREECHARPOINTER(rv);
				FREECHARPOINTER(pp);
				FREECHARPOINTER(rp);
				return b;
			}
			bool FbxIOSettings::ReadXmlPropFromRegistry(String^ regKeyName, String^ regValueName, String^ regPath)
			{
				STRINGTO_CONSTCHAR_ANSI(rk,regKeyName);
				KString srk(rk);
				STRINGTO_CONSTCHAR_ANSI(rv,regValueName);
				KString srv(rv);				
				STRINGTO_CONSTCHAR_ANSI(rp,regPath);
				KString srp(rp);
				bool b = _Ref()->ReadXmlPropFromRegistry(srk,srv,srp);
				FREECHARPOINTER(rk);
				FREECHARPOINTER(rv);				
				FREECHARPOINTER(rp);
				return b;
			}
			bool FbxIOSettings::ReadXmlPropFromMyDocument(String^ subDir, String^ filename)
			{
				STRINGTO_CONSTCHAR_ANSI(sd,subDir);
				KString ssd(sd);
				STRINGTO_CONSTCHAR_ANSI(fn,filename);
				KString sfn(fn);								
				bool b = _Ref()->ReadXmlPropFromMyDocument(ssd,sfn);
				FREECHARPOINTER(sd);
				FREECHARPOINTER(fn);				
				return b;
			}
			bool FbxIOSettings::WriteXmlPropToMyDocument(String^ subDir, String^ filename, String^ propPath)
			{				
				STRINGTO_CONSTCHAR_ANSI(sd,subDir);
				KString ssd(sd);
				STRINGTO_CONSTCHAR_ANSI(fn,filename);
				KString sfn(fn);
				STRINGTO_CONSTCHAR_ANSI(pp,propPath);
				KString spp(pp);
				bool b = _Ref()->WriteXmlPropToMyDocument(ssd,sfn,spp);
				FREECHARPOINTER(sd);
				FREECHARPOINTER(fn);				
				FREECHARPOINTER(pp);				
				return b;
			}
			String^ FbxIOSettings::UserMyDocumentDir::get()
			{
				KString kstr = KFbxIOSettings::GetUserMyDocumentDir();
				CONVERT_KSTRING_TO_STRING(kstr,str);
				return str;
			}

			REF_PROPERTY_GET_DEFINATION_FROM_VALUE(FbxIOSettings,impInfo,FbxSoInfo,ImpInfo);
			REF_PROPERTY_GET_DEFINATION_FROM_VALUE(FbxIOSettings,expInfo,FbxSoInfo,ExpInfo);
			
			FbxUILanguage FbxIOSettings::UILanguage::get()
			{
				return (FbxUILanguage)_Ref()->UILanguage;
			}
			void FbxIOSettings::UILanguage::set(FbxUILanguage value)
			{
				_Ref()->UILanguage = (FBXUILANGUAGE)value;
			}
			String^ FbxIOSettings::GetLanguageLabel(FbxProperty^ prop)
			{
				KString kstr = _Ref()->GetLanguageLabel(*prop->_Ref());
				CONVERT_KSTRING_TO_STRING(kstr,str);
				return str;
			}
			void FbxIOSettings::SetLanguageLabel(FbxProperty^ prop, String^ label)
			{				
				STRINGTO_CONSTCHAR_ANSI(l,label);
				KString kstr(l);
				_Ref()->SetLanguageLabel(*prop->_Ref(),kstr);
			}
			FbxUILanguage FbxIOSettings::GetMaxRuntimeLanguage(String^ regLocation)
			{
				STRINGTO_CONSTCHAR_ANSI(rl,regLocation);
				KString kstr(rl);
				return (FbxUILanguage)_Ref()->Get_Max_Runtime_Language(kstr);
			}
			bool FbxIOSettings::IsEnumExist(FbxProperty^ prop, String^ enumString)
			{
				STRINGTO_CONSTCHAR_ANSI(es,enumString);
				KString kstr(es);
				return _Ref()->IsEnumExist(*prop->_Ref(),kstr);
			}
			int  FbxIOSettings::GetEnumIndex(FbxProperty^ prop, String^ enumString, bool noCase)
			{
				STRINGTO_CONSTCHAR_ANSI(es,enumString);
				KString kstr(es);
				return _Ref()->GetEnumIndex(*prop->_Ref(),kstr,noCase);
			}			
			CLONE_DEFINITION(FbxIOSettings,KFbxIOSettings);
		}
	}
}