#pragma once
#include "stdafx.h"
#include "FbxImporter.h"
#include "FbxStreamOptions.h"
#include "FbxDocument.h"
#include "FbxTakeInfo.h"
#include "FbxDocumentInfo.h"
#include "FbxAxisSystem.h"
#include "FbxSystemUnit.h"
#include "FbxSdkManager.h"
#include "FbxString.h"
#include "FbxClassId.h"

namespace Skill
{
	namespace FbxSDK
	{
		namespace IO
		{	
			void FbxImporter::CollectManagedMemory()
			{
				this->_ImportOptions = nullptr;
				this->_SceneInfo = nullptr;
			}

			FBXOBJECT_DEFINITION(FbxImporter,KFbxImporter);
			bool FbxImporter::Initialize(String^ fileName)
			{
				return FbxIO::Initialize(fileName);
			}			
			Version^ FbxImporter::FileVersion::get()
			{
				int minor,major,revision,build = 0;
				_Ref()->GetFileVersion(major,minor,revision);
				return gcnew Version(major,minor,build,revision);
			}				
			bool FbxImporter::GetDefaultRenderResolution(FbxString^ camName, FbxString^ resolutionMode, double^ %w, double^ %h)
			{
				double pw,ph;
				bool b = _Ref()->GetDefaultRenderResolution(*camName->_Ref(),*resolutionMode->_Ref(),pw,ph);
				w = pw;
				h =  ph;
				return b;
			}
			FbxStreamOptions^ FbxImporter::GetImportOptions(FbxImporter::StreamOptionsGeneration streamOptionsGeneration)
			{
				if(_ImportOptions )
					_ImportOptions->_SetPointer(_Ref()->GetImportOptions((KFbxImporter::EStreamOptionsGeneration)streamOptionsGeneration),false);
				else
					_ImportOptions = FbxCreator::CreateFbxStreamOptions(_Ref()->GetImportOptions((KFbxImporter::EStreamOptionsGeneration)streamOptionsGeneration));
				return _ImportOptions;
			}
			FbxStreamOptions^ FbxImporter::GetImportOptions()
			{
				if(_ImportOptions )
					_ImportOptions->_SetPointer(_Ref()->GetImportOptions(),false);
				else
					_ImportOptions = FbxCreator::CreateFbxStreamOptions(_Ref()->GetImportOptions());
				return _ImportOptions;
			}
			bool FbxImporter::Import(FbxDocument^ document, FbxStreamOptions^ streamOptions)
			{
				return _Ref()->Import(document->_Ref(), streamOptions->_Ref());
			}
			bool FbxImporter::Import(FbxDocument^ document)
			{
				return _Ref()->Import(document->_Ref());
			}
			void FbxImporter::ReleaseImportOptions(FbxStreamOptions^ streamOptions)
			{
				_Ref()->ReleaseImportOptions(streamOptions->_Ref());
			}
			int FbxImporter::TakeCount::get()
			{
				return _Ref()->GetTakeCount();
			}				
			FbxTakeInfo^ FbxImporter::GetTakeInfo(int index)
			{
				KFbxTakeInfo* i = _Ref()->GetTakeInfo(index);
				if(i)
					return gcnew FbxTakeInfo(i);
				return nullptr;
			}
			String^ FbxImporter::CurrentTakeName::get()
			{
				return gcnew String(_Ref()->GetCurrentTakeName());
			}
			REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxImporter,KFbxDocumentInfo,GetSceneInfo(),FbxDocumentInfo,SceneInfo);							
			int  FbxImporter::FileFormat::get()
			{
				return _Ref()->GetFileFormat();
			}
			void FbxImporter::FileFormat::set(int value)
			{
				_Ref()->SetFileFormat(value);
			}				
			bool FbxImporter::IsFBX::get()
			{
				return _Ref()->IsFBX();
			}			
			void FbxImporter::ParseForGlobalSettings(bool state)
			{
				_Ref()->ParseForGlobalSettings(state);
			}
			bool FbxImporter::GetAxisInfo(FbxAxisSystem^ axisSystem, FbxSystemUnit^ systemUnits)
			{
				return _Ref()->GetAxisInfo(axisSystem->_Ref(),systemUnits->_Ref());
			}

			void FbxImporter::ParseForStatistics(bool state)
			{
				_Ref()->ParseForStatistics(state);
			}

#ifndef DOXYGEN_SHOULD_SKIP_THIS
			bool FbxImporter::UpdateImportOptions(FbxStreamOptions^ streamOptions)
			{
				return _Ref()->UpdateImportOptions(streamOptions->_Ref());
			}

#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS			

		}
	}
}