#pragma once
#include "stdafx.h"
#include "FbxObject.h"
#include "FbxClassID.h"
#include "FbxSdkManager.h"
#include "FbxString.h"
#include "FbxStream.h"
#include "FbxEvaluationInfo.h"
#include "FbxProperty.h"
#include "FbxDataType.h"
#include "FbxDocument.h"
#include "FbxScene.h"
#include "FbxLibrary.h"
#include "FbxQuery.h"
#include "FbxObjectMetaData.h"

namespace Skill
{
	namespace FbxSDK
	{

		FbxObject::FbxObject(KFbxObject* obj) : FbxPlug(obj)
		{			
			_Free = false;
		}
		void FbxObject::CollectManagedMemory()
		{
			refTo = nullptr;
			this->_Document = nullptr;
			this->_RootDocument = nullptr;
			this->_Scene = nullptr;
			this->_ParentLibrary = nullptr;
			FbxPlug::CollectManagedMemory();
		}

		FbxObject::~FbxObject()
		{			
			CollectManagedMemory();
			this->!FbxObject();
		}
		FbxObject::!FbxObject()
		{			
		}
		CLONE_DEFINITION(FbxObject,KFbxObject);
		FBXOBJECT_DEFINITION(FbxObject,KFbxObject);		

		VALUE_PROPERTY_GET_DEFINATION(FbxObject,IsAReferenceTo(),bool,IsAReferenceTo);		
		FbxObject^ FbxObject::ReferenceTo::get()
		{
			return refTo;
		}
		VALUE_PROPERTY_GET_DEFINATION(FbxObject,IsReferencedBy(),bool,IsReferencedBy);
		VALUE_PROPERTY_GET_DEFINATION(FbxObject,GetReferencedByCount(),int,ReferencedByCount);		
		FbxObject^ FbxObject::GetReferencedBy(int index)
		{
			KFbxObject* obj = _Ref()->GetReferencedBy(index);
			if(obj)
				return FbxCreator::CreateFbxObject(obj);
			return nullptr;
		}

		String^ FbxObject::Name::get()
		{
			KString kstr = _Ref()->GetName();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		void FbxObject::Name::set(String^ value)
		{
			STRINGTO_CONSTCHAR_ANSI(v,value);
			KString kstr(v);
			_Ref()->SetName(kstr);
		}

		String^ FbxObject::NameWithNameSpacePrefix::get()
		{
			KString kstr = _Ref()->GetNameWithNameSpacePrefix();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}
		String^ FbxObject::NameWithoutNameSpacePrefix::get()
		{
			KString kstr = _Ref()->GetNameWithoutNameSpacePrefix();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		String^ FbxObject::InitialName::get()
		{
			KString kstr = _Ref()->GetInitialName();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		void FbxObject::InitialName::set(String^ value)
		{
			STRINGTO_CONSTCHAR_ANSI(v,value);
			KString kstr(v);
			_Ref()->SetInitialName(kstr);
		}

		String^ FbxObject::NameSpaceOnly::get()
		{
			KString kstr = _Ref()->GetNameSpaceOnly();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		void FbxObject::NameSpaceOnly::set(String^ value)
		{
			STRINGTO_CONSTCHAR_ANSI(v,value);
			KString kstr(v);
			_Ref()->SetNameSpace(kstr);
		}

		String^ FbxObject::NameOnly::get()
		{
			KString kstr = _Ref()->GetNameOnly();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		String^ FbxObject::NameSpacePrefix::get()
		{
			KString kstr = _Ref()->GetNameSpacePrefix();
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		String^ FbxObject::RemovePrefix(String^ name)
		{
			STRINGTOCHAR_ANSI(n,name);
			KString kstr = KFbxObject::RemovePrefix(n);
			//FREECHARPOINTER(n);
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;

		}
		String^ FbxObject::StripPrefix(FbxString^ name)
		{			
			KString kstr = KFbxObject::StripPrefix(*name->_Ref());
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}
		String^ FbxObject::StripPrefix(String^ name)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KString kstr = KFbxObject::StripPrefix(n);
			FREECHARPOINTER(n);
			CONVERT_KSTRING_TO_STRING(kstr,str);
			return str;
		}

		KFbxObjectID FbxObject::UniqueID::get()
		{
			return _Ref()->GetUniqueID();
		}

		kFbxUpdateId FbxObject::GetUpdateId(FbxUpdateIdType updateId)
		{
			return _Ref()->GetUpdateId((KFbxObject::eFbxUpdateIdType)updateId);
		}
		int FbxObject::ContentUnload()
		{
			return _Ref()->ContentUnload();
		}

		int FbxObject::ContentLoad()
		{
			return _Ref()->ContentLoad();
		}

		bool FbxObject::ContentIsLoaded::get()
		{
			return _Ref()->ContentIsLoaded();
		}

		void FbxObject::ContentDecrementLockCount()
		{
			_Ref()->ContentDecrementLockCount();
		}		
		void FbxObject::ContentIncrementLockCount()
		{
			_Ref()->ContentIncrementLockCount();
		}
		bool FbxObject::ContentIsLocked::get()
		{
			return _Ref()->ContentIsLocked();
		}

		bool FbxObject::ContentWriteTo(FbxStream^ stream)
		{
			return _Ref()->ContentWriteTo(*stream->_Ref());
		}
		bool FbxObject::ContentReadFrom(FbxStream^ stream)
		{
			return _Ref()->ContentReadFrom(*stream->_Ref());
		}
		bool FbxObject::Selected::get()
		{
			return _Ref()->GetSelected();
		}
		void FbxObject::Selected::set(bool value)
		{
			_Ref()->SetSelected(value);
		}

		bool FbxObject::Evaluate(FbxProperty^ prop,FbxEvaluationInfo^ evaluationInfo)
		{
			return _Ref()->Evaluate(*prop->_Ref(),evaluationInfo->_Ref());
		}

		FbxProperty^ FbxObject::GetFirstProperty()
		{
			KFbxProperty p = _Ref()->GetFirstProperty();
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			return pro;
		}
		FbxProperty^ FbxObject::GetNextProperty(FbxProperty^ prop)
		{
			KFbxProperty p = _Ref()->GetNextProperty(*prop->_Ref());
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			return pro;
		}
		FbxProperty^ FbxObject::FindProperty(String^ name, bool caseSensitive)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxProperty p = _Ref()->FindProperty(n,caseSensitive);
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			FREECHARPOINTER(n);
			return pro;
		}
		FbxProperty^ FbxObject::FindProperty(String^ name, FbxDataType^ dataType, bool caseSensitive)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxProperty p = _Ref()->FindProperty(n,*dataType->_Ref(),caseSensitive);
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			FREECHARPOINTER(n);
			return pro;
		}
		FbxProperty^ FbxObject::FindPropertyHierarchical(String^ name, bool caseSensitive)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxProperty p = _Ref()->FindPropertyHierarchical(n,caseSensitive);
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			FREECHARPOINTER(n);
			return pro;
		}

		/*FbxProperty^ FbxObject::FindPropertyHierarchical(String^ name, FbxDataType^ dataType, bool caseSensitive)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxProperty p = _Ref()->FindPropertyHierarchical(n,*dataType->type,caseSensitive);
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->pro = p;
			FREECHARPOINTER(n);
			return pro;
		}*/
		FbxProperty^ FbxObject::GetRootProperty()
		{
			KFbxProperty p = _Ref()->GetRootProperty();
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			return pro;
		}
		FbxProperty^ FbxObject::GetClassRootProperty()
		{
			KFbxProperty p = _Ref()->GetClassRootProperty();
			FbxProperty^ pro = gcnew FbxProperty();
			*pro->_FbxProperty = p;
			return pro;
		}

		String^ FbxObject::Url::get()
		{
			return gcnew String(_Ref()->GetUrl());
		}
		void FbxObject::Url::set(String^ value)
		{
			STRINGTOCHAR_ANSI(n,value);
			_Ref()->SetUrl(n);
			FREECHARPOINTER(n);
		}
		bool FbxObject::PopulateLoadSettings(FbxObject^ settings,String^ fileName)
		{
			STRINGTOCHAR_ANSI(f,fileName);
			bool b = _Ref()->PopulateLoadSettings(settings->_Ref(),f);
			FREECHARPOINTER(f);
			return b;
		}
		bool FbxObject::Load(String^ fileName)
		{
			STRINGTOCHAR_ANSI(f,fileName);
			bool b = _Ref()->Load(f);
			FREECHARPOINTER(f);
			return b;
		}
		bool FbxObject::PopulateSaveSettings(FbxObject^ settings,String^ fileName)
		{
			STRINGTOCHAR_ANSI(f,fileName);
			bool b = _Ref()->PopulateSaveSettings(settings->_Ref(),f);
			FREECHARPOINTER(f);
			return b;
		}
		bool FbxObject::Save(String^ fileName)
		{		
			STRINGTOCHAR_ANSI(f,fileName);
			bool b = _Ref()->Save(f);
			FREECHARPOINTER(f);
			return b;		
		}		

		REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxObject,KFbxDocument,GetDocument(),FbxDocument,Document);		

		REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxObject,KFbxDocument,GetRootDocument(),FbxDocument,RootDocument);		

		REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxObject,KFbxScene,GetScene(),FbxScene,Scene);

		String^ FbxObject::Localize(String^ ID,String^ Default)
		{
			STRINGTO_CONSTCHAR_ANSI(id,ID);
			const char* s;
			if(Default )
			{
				STRINGTO_CONSTCHAR_ANSI(def,Default);
				s = _Ref()->Localize(id,def);				
				FREECHARPOINTER(def);
			}
			else
				s = _Ref()->Localize(id);
			FREECHARPOINTER(id);
			return gcnew String(s);
		}
		REF_PROPERTY_GET_DEFINATION_FROM_REF(FbxObject,KFbxLibrary,GetParentLibrary(),FbxLibrary,ParentLibrary);		


		bool FbxObject::ConnectSrcObject(FbxObject^ obj,FbxConnectionType type)
		{
			return _Ref()->ConnectSrcObject(obj->_Ref(),(kFbxConnectionType)type);
		}
		bool FbxObject::IsConnectedSrcObject(FbxObject^ obj)
		{
			return _Ref()->IsConnectedSrcObject(obj->_Ref());
		}
		bool FbxObject::DisconnectSrcObject(FbxObject^ obj)
		{
			return _Ref()->DisconnectSrcObject(obj->_Ref());
		}

		/*bool FbxObject::DisconnectAllSrcObject()
		{
			return _Ref()->DisconnectAllSrcObject();
		}
		bool FbxObject::DisconnectAllSrcObject(FbxCriteria^ criteria)
		{
			return _Ref()->DisconnectAllSrcObject(*criteria->_Ref());
		}
		bool FbxObject::DisconnectAllSrcObject(FbxClassId^ classId)
		{
			return _Ref()->DisconnectAllSrcObject(*classId->_Ref());
		}
		bool FbxObject::DisconnectAllSrcObject(FbxClassId^ classId,FbxCriteria^ criteria)
		{
			return _Ref()->DisconnectAllSrcObject(*classId->_Ref(),*criteria->_Ref());
		}*/
		
		int FbxObject::GetSrcObjectCount()
		{
			return _Ref()->GetSrcObjectCount();
		}
		int FbxObject::GetSrcObjectCount(FbxCriteria^ criteria)
		{
			return _Ref()->GetSrcObjectCount(*criteria->_Ref());
		}
		int FbxObject::GetSrcObjectCount(FbxClassId^ classId)
		{
			return _Ref()->GetSrcObjectCount(*classId->_Ref());
		}
		/*int FbxObject::GetSrcObjectCount(FbxClassId^ classId,FbxCriteria^ criteria)
		{
			return _Ref()->GetSrcObjectCount(*classId->_Ref(),*criteria->_Ref());
		}*/


		FbxObject^ FbxObject::GetSrcObject(int index)
		{
			KFbxObject* obj = _Ref()->GetSrcObject(index);
			if(obj)
				return FbxCreator::CreateFbxObject(obj);
			return nullptr;
		}
		/*FbxObject^ FbxObject::GetSrcObject(FbxCriteria^ criteria,int index)
		{
			KFbxObject* obj = _Ref()->GetSrcObject(*criteria->criteria,index);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}*/
		FbxObject^ FbxObject::GetSrcObject(FbxClassId^ classId,int index)
		{
			KFbxObject* obj = _Ref()->GetSrcObject(*classId->_Ref(),index);
			if(obj)
				return FbxCreator::CreateFbxObject(obj);
			return nullptr;
		}
		/*FbxObject^ FbxObject::GetSrcObject(FbxClassId^ classId,FbxCriteria^ criteria,int index)
		{
			KFbxObject* obj = _Ref()->GetSrcObject(*classId->id,*criteria->criteria,index);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}

		FbxObject^ FbxObject::FindSrcObject(String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindSrcObject(n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindSrcObject(FbxCriteria^ criteria,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindSrcObject(*criteria->criteria,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindSrcObject(FbxClassId^ classId,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindSrcObject(*classId->id,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindSrcObject(FbxClassId^ classId,FbxCriteria^ criteria,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindSrcObject(*classId->id,*criteria->criteria,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
*/

		bool FbxObject::ConnectDstObject(FbxObject^ obj,FbxConnectionType type)
		{
			return _Ref()->ConnectDstObject(obj->_Ref(),(kFbxConnectionType)type);
		}
		bool FbxObject::IsConnectedDstObject(FbxObject^ obj)
		{
			return _Ref()->IsConnectedDstObject (obj->_Ref());
		}
		bool FbxObject::DisconnectDstObject(FbxObject^ obj)
		{
			return _Ref()->DisconnectDstObject(obj->_Ref());
		}



		/*bool FbxObject::DisconnectAllDstObject()
		{
			return _Ref()->DisconnectAllDstObject();
		}
		bool FbxObject::DisconnectAllDstObject(FbxCriteria^ criteria)
		{
			return _Ref()->DisconnectAllDstObject(*criteria->criteria);
		}
		bool FbxObject::DisconnectAllDstObject(FbxClassId^ classId)
		{
			return _Ref()->DisconnectAllDstObject(*classId->id);
		}
		bool FbxObject::DisconnectAllDstObject(FbxClassId^ classId,FbxCriteria^ criteria)
		{
			return _Ref()->DisconnectAllDstObject(*classId->id,*criteria->criteria);
		}*/
		
		int FbxObject::GetDstObjectCount()
		{
			return _Ref()->GetDstObjectCount();
		}
		/*int FbxObject::GetDstObjectCount(FbxCriteria^ criteria)
		{
			return _Ref()->GetDstObjectCount(*criteria->_Ref());
		}*/
		int FbxObject::GetDstObjectCount(FbxClassId^ classId)
		{
			return _Ref()->GetDstObjectCount(*classId->_Ref());
		}
		/*int FbxObject::GetDstObjectCount(FbxClassId^ classId,FbxCriteria^ criteria)
		{
			return _Ref()->GetDstObjectCount(*classId->_Ref(),*criteria->_Ref());
		}*/



		/*FbxObject^ FbxObject::GetDstObject(int index)
		{
			KFbxObject* obj = _Ref()->GetDstObject(index);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}*/
		/*FbxObject^ FbxObject::GetDstObject(FbxCriteria^ criteria,int index)
		{
			KFbxObject* obj = _Ref()->GetDstObject(*criteria->criteria,index);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}*/
		FbxObject^ FbxObject::GetDstObject(FbxClassId^ classId,int index)
		{
			KFbxObject* obj = _Ref()->GetDstObject(*classId->_Ref(),index);
			if(obj)
				return FbxCreator::CreateFbxObject(obj);
			return nullptr;
		}
		/*FbxObject^ FbxObject::GetDstObject(FbxClassId^ classId,FbxCriteria^ criteria,int index)
		{
			KFbxObject* obj = _Ref()->GetDstObject(*classId->id,*criteria->criteria,index);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}*/

		/*FbxObject^ FbxObject::FindDstObject(String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindDstObject(n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindDstObject(FbxCriteria^ criteria,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindDstObject(*criteria->criteria,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindDstObject(FbxClassId^ classId,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindDstObject(*classId->id,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
		FbxObject^ FbxObject::FindDstObject(FbxClassId^ classId,FbxCriteria^ criteria,String^ name,int startIndex)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			KFbxObject* obj = _Ref()->FindDstObject(*classId->id,*criteria->criteria,n,startIndex);
			FREECHARPOINTER(n);
			if(obj)
				return gcnew FbxObject(obj);
			return nullptr;
		}
*/

#ifndef DOXYGEN_SHOULD_SKIP_THIS					
		FbxClassId^ FbxObject::GetRuntimeClassId()
		{
			FbxClassId^ id = gcnew FbxClassId();
			*id->_Ref() = _Ref()->GetRuntimeClassId();
			return id;
		}
		void FbxObject::SetObjectFlags(ObjectFlag flags, bool value)
		{				
			_Ref()->SetObjectFlags((KFbxObject::EObjectFlag)flags,value);
		}
		bool FbxObject::GetObjectFlags(ObjectFlag flags)
		{
			return _Ref()->GetObjectFlags((KFbxObject::EObjectFlag)flags);
		}

		// All flags replaced at once. This includes overriding the runtime flags, so
		// most likely you'd want to do something like this:
		//						
		// All flags at once, as a bitmask		
		kUInt FbxObject::ObjectFlags::get()
		{
			return _Ref()->GetObjectFlags();
		}
		void FbxObject::ObjectFlags::set(kUInt value)
		{
			_Ref()->SetObjectFlags(value);
		}
		//FbxObjectHandle &GetPropertyHandle() { return RootProperty.mPropertyHandle; }

#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS		
		
	}
}