#pragma once
#include "stdafx.h"
#include "FbxReader.h"
#include "FbxSdkManager.h"
#include "FbxImporter.h"
#include "FbxString.h"
#include "FbxStreamOptions.h"
#include "FbxDocument.h"
#include "FbxError.h"
#include "FbxAxisSystem.h"
#include "FbxSystemUnit.h"

namespace Skill
{
	namespace FbxSDK
	{
		namespace IO
		{

			void FbxReader::CollectManagedMemory()
			{
				this->readOptions = nullptr;
				this->_KError = nullptr;
			}						
			Version^ FbxReader::GetVersion()
			{					
				int minor,major,revision,build = 0;
				_Ref()->GetVersion(major,minor,revision);
				return gcnew Version(major,minor,build,revision);
			}

			bool FbxReader::FileOpen(String^ fileName)
			{				
				STRINGTOCHAR_ANSI(f,fileName);
				bool b = _Ref()->FileOpen(f);
				FREECHARPOINTER(f);
				return b;
			}
			bool FbxReader::FileClose()				
			{
				return _Ref()->FileClose();
			}
			bool FbxReader::IsFileOpen::get()
			{
				return _Ref()->IsFileOpen();
			}				
			FbxStreamOptions^ FbxReader::GetReadOptions(bool parseFileAsNeeded)
			{
				if(readOptions)
					readOptions->_SetPointer(_Ref()->GetReadOptions(parseFileAsNeeded),false);
				else
					readOptions = FbxCreator::CreateFbxStreamOptions(_Ref()->GetReadOptions(parseFileAsNeeded));
				return readOptions;
			}
			FbxStreamOptions^ FbxReader::GetReadOptions()
			{
				return GetReadOptions(false);
			}
			bool FbxReader::Read(FbxDocument^ document, FbxStreamOptions^ streamOptions)
			{
				return _Ref()->Read(document->_Ref(), streamOptions->_Ref());
			}
			REF_PROPERTY_GET_DEFINATION_FROM_VALUE(FbxReader,GetError(),FbxError,KError);			
			FbxReader::Error FbxReader::LastErrorID::get()
			{
				return (Error)_Ref()->GetLastErrorID();
			}				
			String^ FbxReader::LastErrorString::get()
			{
				return gcnew String(_Ref()->GetLastErrorString());
			}				
			void FbxReader::GetMessage(FbxString^ message)
			{
				_Ref()->GetMessage(*message->_Ref());
			}
			void FbxReader::ClearMessage()
			{
				_Ref()->ClearMessage();
			}
			bool FbxReader::FileOpen(String^ fileName, FileOpenSpecialFlags flags)
			{				
				STRINGTOCHAR_ANSI(f,fileName);
				bool b = _Ref()->FileOpen(f,(KFbxReader::EFileOpenSpecialFlags)flags);
				FREECHARPOINTER(f);
				return b;
			}
			bool FbxReader::GetAxisInfo(FbxAxisSystem^ axisSystem, FbxSystemUnit^ systemUnits) 
			{
				return _Ref()->GetAxisInfo(axisSystem->_Ref(),systemUnits->_Ref());
			}
		}
	}
}