#pragma once
#include "stdafx.h"
#include "Fbx.h"
#include "kfbxio/kfbxReader.h"

namespace Skill
{
	namespace FbxSDK
	{
		ref class FbxSdkManager;
		ref class FbxString;		
		ref class FbxDocument;
		ref class FbxError;
		ref class FbxAxisSystem;
		ref class FbxSystemUnit;

		namespace IO
		{
			ref class FbxStreamOptions;
			ref class FbxImporter;
			public ref class FbxReader : IFbxNativePointer
			{
				BASIC_CLASS_DECLARE(FbxReader,KFbxReader);
				INATIVEPOINTER_DECLARE(FbxReader,KFbxReader);
			protected:
				FbxStreamOptions^ readOptions;
			public:								
				virtual Version^ GetVersion();

				virtual bool FileOpen(String^ fileName);
				//virtual bool FileOpen(KFile * pFile);
				virtual bool FileClose();
				virtual property bool IsFileOpen
				{
					bool get();
				}

				virtual FbxStreamOptions^ GetReadOptions(bool parseFileAsNeeded);
				virtual FbxStreamOptions^ GetReadOptions();
				virtual bool Read(FbxDocument^ document, FbxStreamOptions^ streamOptions);

				//! Error codes
				enum class Error
				{
					FileCorrupted,
					FileVersionNotSupportedYet,
					FileVersionNotSupportedAnymore,
					FileNotOpened,
					FileNotCreated,
					WrongPassword,
					StreamOptionsNotSet,
					InvalidDocumentHandle,
					DocumentNotSupported,
					UnresolvedExternalReferences, // this is a warning
					UnidentifiedError,
					ErrorCount
				};

				REF_PROPERTY_GET_DECLARE(FbxError,KError);
				property Error LastErrorID
				{
					Error get();
				}
				property String^ LastErrorString
				{
					String^ get();
				}

				void GetMessage(FbxString^ message);
				void ClearMessage();

				//	typedef KFbxReader* (*CreateFuncType)(KFbxSdkManager& pManager,
				//		KFbxImporter& pImporter,
				//		int pID);

				//	typedef void (*IOSettingsFillerFuncType)(KFbxIOSettings& pIOS);

				enum class InfoRequest {
					InfoExtension, // return a null terminated char const* const*
					InfoDescriptions, // return a null terminated char const* const*
					Reserved1 = 0xFBFB,
				};

				//	typedef void* (*GetInfoFuncType)(KInfoRequest pRequest, int pReaderTypeId);			

			public:
				enum class FileOpenSpecialFlags
				{
					ParseForGlobalSettings = 1,
					ParseForStatistics = 2
				};

				virtual bool FileOpen(String^ fileName, FileOpenSpecialFlags flags);
				virtual bool GetAxisInfo(FbxAxisSystem^ axisSystem, FbxSystemUnit^ systemUnits);
				//virtual bool GetStatistics(FbxStatistics* pStats) {return false; };
				
			};

		}
	}
}