#pragma once
#include "stdafx.h"
#include "FbxStreamOptions.h"
#include "FbxProperty.h"
#include "FbxString.h"

namespace Skill
{
	namespace FbxSDK
	{
		namespace IO
		{						

			bool FbxStreamOptions::SetOption(String^ name, int value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				bool b = _Ref()->SetOption<int>(n,value);					
				FREECHARPOINTER(n);
				return b;
			}
			bool FbxStreamOptions::SetOption(String^ name, bool value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				bool b = _Ref()->SetOption<bool>(n,value);					
				FREECHARPOINTER(n);
				return b;
			}
			bool FbxStreamOptions::SetOption(String^ name, String^ value)
			{
				STRINGTO_CONSTCHAR_ANSI(n,name);
				KString kstr(n);
				bool b = _Ref()->SetOption<KString>(n,kstr);
				FREECHARPOINTER(n);
				return b;
			}
										
			void FbxStreamOptions::Reset()
			{
				_Ref()->Reset();
			}
			FbxProperty^ FbxStreamOptions::GetOption(FbxString^ name)
			{
				return gcnew FbxProperty(_Ref()->GetOption(*name->_Ref()));
			}
			FbxProperty^ FbxStreamOptions::GetOption(String^ name)
			{				
				STRINGTO_CONSTCHAR_ANSI(n,name);
				FbxProperty^ p = gcnew FbxProperty(&_Ref()->GetOption(n));
				FREECHARPOINTER(n);
				return p;
			}
			bool FbxStreamOptions::SetOption(FbxProperty^ fProperty)
			{
				return _Ref()->SetOption(*fProperty->_Ref());
			}
			bool FbxStreamOptions::CopyFrom(FbxStreamOptions^ streamOptionsSrc)
			{
				return _Ref()->CopyFrom(streamOptionsSrc->_Ref());
			}
#ifndef DOXYGEN_SHOULD_SKIP_THIS			

			CLONE_DEFINITION(FbxStreamOptions,KFbxStreamOptions);
#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS			
		}
	}
}