#pragma once
#include "stdafx.h"
#include "FbxXRefManager.h"
#include "FbxProperty.h"
#include "FbxString.h"
#include "FbxDocument.h"

namespace Skill
{
	namespace FbxSDK
	{	
		void FbxXRefManager::CollectManagedMemory()
		{
		}
		int FbxXRefManager::GetUrlCount(FbxProperty^ p)
		{
			return KFbxXRefManager::GetUrlCount(*p->_Ref());
		}
		int FbxXRefManager::GetUrlCount(FbxString^ url)
		{
			return KFbxXRefManager::GetUrlCount(*url->_Ref());
		}
		int FbxXRefManager::GetUrlCount(String^ url)
		{
			STRINGTO_CONSTCHAR_ANSI(u,url);
			KString s(u);
			FREECHARPOINTER(u);
			return KFbxXRefManager::GetUrlCount(s);
		}

		bool FbxXRefManager::IsRelativeUrl(FbxProperty^ p,int index)
		{
			return KFbxXRefManager::IsRelativeUrl(*p->_Ref(),index);
		}

		String^ FbxXRefManager::GetUrl(FbxProperty^ p,int index)
		{
			KString s = KFbxXRefManager::GetUrl(*p->_Ref(),index);
			CONVERT_KSTRING_TO_STRING(s,str);
			return str;
		}
		void FbxXRefManager::GetUrl(FbxProperty^ p,int index,FbxString^ urlOut)
		{
			*urlOut->_Ref() = KFbxXRefManager::GetUrl(*p->_Ref(),index);			
		}

		/** Return The nth Relative Url stored in the property
		* upon return the pXRefProject will return the name of the XRef Project closest to the Url of the property
		* \return The Url if it is valid relative
		*/
		bool FbxXRefManager::GetResolvedUrl(FbxProperty^ p ,int index,FbxString^ resolvedPath)
		{
			return _Ref()->GetResolvedUrl(*p->_Ref(),index,*resolvedPath->_Ref());
		}
		bool FbxXRefManager::GetResolvedUrl(FbxProperty^ p ,int index,String^ resolvedPath)
		{
			STRINGTO_CONSTCHAR_ANSI(r,resolvedPath);
			KString s(r);
			FREECHARPOINTER(r);
			return _Ref()->GetResolvedUrl(*p->_Ref(),index,s);
		}	


		bool FbxXRefManager::GetResolvedUrl(String^ url,FbxDocument^ doc, String^ resolvedPath)
		{
			STRINGTO_CONSTCHAR_ANSI(u,url);
			STRINGTO_CONSTCHAR_ANSI(r,resolvedPath);
			KString s(r);			
			bool b = _Ref()->GetResolvedUrl(u,doc->_Ref(),s);
			FREECHARPOINTER(r);
			FREECHARPOINTER(u);
			return b;
		}

		bool FbxXRefManager::GetFirstMatchingUrl(String^ prefix, String^ optExt,FbxDocument^ doc,String^ resolvedPath)
		{

			STRINGTO_CONSTCHAR_ANSI(pf,prefix);
			STRINGTO_CONSTCHAR_ANSI(pe,optExt);
			STRINGTO_CONSTCHAR_ANSI(r,resolvedPath);
			bool b = _Ref()->GetFirstMatchingUrl(pf,pe,doc->_Ref(),KString(r));
			FREECHARPOINTER(pf);
			FREECHARPOINTER(pe);
			FREECHARPOINTER(r);
			return b;
		}
		bool FbxXRefManager::AddXRefProject   (String^ name,String^ url)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			STRINGTO_CONSTCHAR_ANSI(u,url);
			bool b = _Ref()->AddXRefProject(n,u);
			FREECHARPOINTER(n);
			FREECHARPOINTER(u);
			return b;
		}
		bool FbxXRefManager::AddXRefProject(String^ name,String^ extension,String^ url)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			STRINGTO_CONSTCHAR_ANSI(u,url);
			STRINGTO_CONSTCHAR_ANSI(e,extension);
			bool b = _Ref()->AddXRefProject(n,e,u);
			FREECHARPOINTER(n);
			FREECHARPOINTER(u);
			FREECHARPOINTER(e);
			return b;
		}

		bool FbxXRefManager::AddXRefProject(FbxDocument^ doc)
		{
			return _Ref()->AddXRefProject(doc->_Ref());
		}
		bool FbxXRefManager::RemoveXRefProject(String^ name)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			bool b = _Ref()->RemoveXRefProject(n);
			FREECHARPOINTER(n);
			return b;
		}
		bool FbxXRefManager::RemoveAllXRefProjects()
		{
			return _Ref()->RemoveAllXRefProjects();
		}

		int FbxXRefManager::XRefProjectCount::get()
		{
			return _Ref()->GetXRefProjectCount();
		}
		String^ FbxXRefManager::GetXRefProjectName(int index)
		{
			return gcnew String(_Ref()->GetXRefProjectName(index));
		}

		String^ FbxXRefManager::GetXRefProjectUrl(String^ name)
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			const char* nStr = _Ref()->GetXRefProjectUrl(n);
			FREECHARPOINTER(n);
			if(nStr)
				return gcnew String(nStr);			
			return nullptr;
		}
		String^ FbxXRefManager::GetXRefProjectUrl(int index)
		{
			const char* n = _Ref()->GetXRefProjectUrl(index);
			if(n)
				return gcnew String(n);
			return nullptr;
		}		
		/*bool FbxXRefManager::HasXRefProject(String^ name)		
		{
			STRINGTO_CONSTCHAR_ANSI(n,name);
			bool b = _Ref()->HasXRefProject(n);
			FREECHARPOINTER(n);
			return b;
		}*/

		bool FbxXRefManager::GetResolvedUrl(String^ url,String^ resolvePath)
		{
			STRINGTO_CONSTCHAR_ANSI(u,url);
			STRINGTO_CONSTCHAR_ANSI(r,resolvePath);
			bool b = _Ref()->GetResolvedUrl(u,KString(r));
			FREECHARPOINTER(u);
			FREECHARPOINTER(r);
			return b;
		}
	}	
}